/*************************************************************
 * By: Coralys Cubero Rivera
 * Date: 2019
 *************************************************************/

package uprrp.tania;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;

public class SendRegistrationToServer extends AsyncTask <String, String, String> {


    private Context context;

    public SendRegistrationToServer(Context context){
        this.context = context.getApplicationContext();
    }
    @Override
    protected String doInBackground(String... strings) {

        String json  = null;
        try {
            json = URLEncoder.encode("data", "UTF-8") + "=" + URLEncoder.encode(strings[0], "UTF-8");
            //Log.d("REGISTRATION", json);
        } catch (UnsupportedEncodingException e) {
            Log.e("REGISTRATION ERROR", e.getMessage());
        }

        String text = "";
        BufferedReader reader = null;

        // Send data
        try
        {
            // Defined URL  where to send data
            URL url = new URL("https://tania.uprrp.edu/registrationAnd.php");

            // Send POST data request
            URLConnection conn = url.openConnection();
            conn.setDoOutput(true);
            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
            assert json != null;
            wr.write(json);
            wr.flush();

            // Get the server response
            reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            StringBuilder sb = new StringBuilder();
            String line = null;

            // Read Server Response
            while((line = reader.readLine()) != null)
            {
                // Append server response in string
                sb.append(line).append("\n");
            }

            text = sb.toString();
        }
        catch(Exception ex) {
            Log.e("REGISTRATION ERROR", ex.getMessage());
        }
        finally
        {
            try
            {
                assert reader != null;
                reader.close();
            }
            catch(Exception ex) {
                Log.e("REGISTRATION ERROR", ex.getMessage());
            }
        }

        return text;

    }

    @Override
    protected void onPostExecute(String s) {
        Log.d("REGISTRATION RESPOND", "The server's response is: " + s);

        String ss = s.substring(0,6);
        String se = s.substring(0,8);
        if (ss.equals("Succes")){

            SharedPreferences prefs = context.getSharedPreferences("prefs", Context.MODE_PRIVATE);
            SharedPreferences.Editor editor = prefs.edit();
            editor.putBoolean("needsToRegister", false);
            editor.apply();

            try {
                Intent intent = new Intent(context, MainActivity.class);
                intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                context.startActivity(intent);
            }
            catch (Exception e){
                Log.d("REGISTRATION TO MAIN ACTIVITY", e.getMessage());
            }


        }

        else if (se.equals("Error:to")){
            Toast.makeText(context, "You have already registered. Please refer to the login page.", Toast.LENGTH_LONG).show();
        }

        else {
            Toast.makeText(context, "An error occured while trying to register. Please start again.", Toast.LENGTH_LONG).show();
        }



    }

}
